#!/usr/bin/env bash

function log() {
    echo -e "\033[33m$@\033[0m"
}

function feed_rapid7_fdns { # dataset
    dataset=$1
    line=$(curl -s https://opendata.rapid7.com/sonar.fdns_v2/ | grep "href=\".\+-fdns_$dataset.json.gz\"")
    link="https://opendata.rapid7.com$(echo "$line" | cut -d'"' -f2)"
    log "Reading $(echo "$dataset" | awk '{print toupper($0)}') records from $link"
    curl -L "$link" | gunzip
}

function feed_rapid7_rdns {
    dataset=$1
    line=$(curl -s https://opendata.rapid7.com/sonar.rdns_v2/ | grep "href=\".\+-rdns.json.gz\"")
    link="https://opendata.rapid7.com$(echo "$line" | cut -d'"' -f2)"
    log "Reading PTR records from $link"
    curl -L "$link" | gunzip
}

feed_rapid7_rdns | ./feed_dns.py rapid7
feed_rapid7_fdns a | ./feed_dns.py rapid7 --ip4-cache 536870912
# feed_rapid7_fdns aaaa | ./feed_dns.py rapid7 --ip6-cache 536870912
feed_rapid7_fdns cname | ./feed_dns.py rapid7
